////////////////////////////////////////////////////////////////////////////////
//! \file
//! \author Adam M Phillippy
//! \date 04/18/2005
//!
//! \brief Source for utility_AMOS.hh
//!
////////////////////////////////////////////////////////////////////////////////
 
#include "utility_AMOS.hh"
#include <algorithm>
#include <cstring>
using namespace AMOS;
using namespace std;
 

const char COMPLEMENT_DNA[256] =
  {
      static_cast<const char>(0),  static_cast<const char>(1),  static_cast<const char>(2),  static_cast<const char>(3),  static_cast<const char>(4),  static_cast<const char>(5),  static_cast<const char>(6),  static_cast<const char>(7),  static_cast<const char>(8),  static_cast<const char>(9), static_cast<const char>(10), static_cast<const char>(11), static_cast<const char>(12), static_cast<const char>(13), static_cast<const char>(14), static_cast<const char>(15),
     static_cast<const char>(16), static_cast<const char>(17), static_cast<const char>(18), static_cast<const char>(19), static_cast<const char>(20), static_cast<const char>(21), static_cast<const char>(22), static_cast<const char>(23), static_cast<const char>(24), static_cast<const char>(25), static_cast<const char>(26), static_cast<const char>(27), static_cast<const char>(28), static_cast<const char>(29), static_cast<const char>(30), static_cast<const char>(31),
     static_cast<const char>(32), static_cast<const char>(33), static_cast<const char>(34), static_cast<const char>(35), static_cast<const char>(36), static_cast<const char>(37), static_cast<const char>(38), static_cast<const char>(39), static_cast<const char>(40), static_cast<const char>(41), static_cast<const char>(42), static_cast<const char>(43), static_cast<const char>(44), static_cast<const char>(45), static_cast<const char>(46), static_cast<const char>(47),
     static_cast<const char>(48), static_cast<const char>(49), static_cast<const char>(50), static_cast<const char>(51), static_cast<const char>(52), static_cast<const char>(53), static_cast<const char>(54), static_cast<const char>(55), static_cast<const char>(56), static_cast<const char>(57), static_cast<const char>(58), static_cast<const char>(59), static_cast<const char>(60), static_cast<const char>(61), static_cast<const char>(62), static_cast<const char>(63),
     static_cast<const char>(64),static_cast<const char>('T'),static_cast<const char>('V'),static_cast<const char>('G'),static_cast<const char>('H'), static_cast<const char>(69), static_cast<const char>(70),static_cast<const char>('C'),static_cast<const char>('D'), static_cast<const char>(73), static_cast<const char>(74),static_cast<const char>('M'), static_cast<const char>(76),static_cast<const char>('K'),static_cast<const char>('N'), static_cast<const char>(79),
     static_cast<const char>(80), static_cast<const char>(81),static_cast<const char>('Y'),static_cast<const char>('S'),static_cast<const char>('A'), static_cast<const char>(85),static_cast<const char>('B'),static_cast<const char>('W'),static_cast<const char>('X'),static_cast<const char>('R'), static_cast<const char>(90), static_cast<const char>(91), static_cast<const char>(92), static_cast<const char>(93), static_cast<const char>(94), static_cast<const char>(95),
     static_cast<const char>(96),static_cast<const char>('t'),static_cast<const char>('v'),static_cast<const char>('g'),static_cast<const char>('h'),static_cast<const char>(101),static_cast<const char>(102),static_cast<const char>('c'),static_cast<const char>('d'),static_cast<const char>(105),static_cast<const char>(106),static_cast<const char>('m'),static_cast<const char>(108),static_cast<const char>('k'),static_cast<const char>('n'),static_cast<const char>(111),
    static_cast<const char>(112),static_cast<const char>(113),static_cast<const char>('y'),static_cast<const char>('s'),static_cast<const char>('a'),static_cast<const char>(117),static_cast<const char>('b'),static_cast<const char>('w'),static_cast<const char>('x'),static_cast<const char>('r'),static_cast<const char>(122),static_cast<const char>(123),static_cast<const char>(124),static_cast<const char>(125),static_cast<const char>(126),static_cast<const char>(127),
    static_cast<const char>(128),static_cast<const char>(129),static_cast<const char>(130),static_cast<const char>(131),static_cast<const char>(132),static_cast<const char>(133),static_cast<const char>(134),static_cast<const char>(135),static_cast<const char>(136),static_cast<const char>(137),static_cast<const char>(138),static_cast<const char>(139),static_cast<const char>(140),static_cast<const char>(141),static_cast<const char>(142),static_cast<const char>(143),
    static_cast<const char>(144),static_cast<const char>(145),static_cast<const char>(146),static_cast<const char>(147),static_cast<const char>(148),static_cast<const char>(149),static_cast<const char>(150),static_cast<const char>(151),static_cast<const char>(152),static_cast<const char>(153),static_cast<const char>(154),static_cast<const char>(155),static_cast<const char>(156),static_cast<const char>(157),static_cast<const char>(158),static_cast<const char>(159),
    static_cast<const char>(160),static_cast<const char>(161),static_cast<const char>(162),static_cast<const char>(163),static_cast<const char>(164),static_cast<const char>(165),static_cast<const char>(166),static_cast<const char>(167),static_cast<const char>(168),static_cast<const char>(169),static_cast<const char>(170),static_cast<const char>(171),static_cast<const char>(172),static_cast<const char>(173),static_cast<const char>(174),static_cast<const char>(175),
    static_cast<const char>(176),static_cast<const char>(177),static_cast<const char>(178),static_cast<const char>(179),static_cast<const char>(180),static_cast<const char>(181),static_cast<const char>(182),static_cast<const char>(183),static_cast<const char>(184),static_cast<const char>(185),static_cast<const char>(186),static_cast<const char>(187),static_cast<const char>(188),static_cast<const char>(189),static_cast<const char>(190),static_cast<const char>(191),
    static_cast<const char>(192),static_cast<const char>(193),static_cast<const char>(194),static_cast<const char>(195),static_cast<const char>(196),static_cast<const char>(197),static_cast<const char>(198),static_cast<const char>(199),static_cast<const char>(200),static_cast<const char>(201),static_cast<const char>(202),static_cast<const char>(203),static_cast<const char>(204),static_cast<const char>(205),static_cast<const char>(206),static_cast<const char>(207),
    static_cast<const char>(208),static_cast<const char>(209),static_cast<const char>(210),static_cast<const char>(211),static_cast<const char>(212),static_cast<const char>(213),static_cast<const char>(214),static_cast<const char>(215),static_cast<const char>(216),static_cast<const char>(217),static_cast<const char>(218),static_cast<const char>(219),static_cast<const char>(220),static_cast<const char>(221),static_cast<const char>(222),static_cast<const char>(223),
    static_cast<const char>(224),static_cast<const char>(225),static_cast<const char>(226),static_cast<const char>(227),static_cast<const char>(228),static_cast<const char>(229),static_cast<const char>(230),static_cast<const char>(231),static_cast<const char>(232),static_cast<const char>(233),static_cast<const char>(234),static_cast<const char>(235),static_cast<const char>(236),static_cast<const char>(237),static_cast<const char>(238),static_cast<const char>(239),
    static_cast<const char>(240),static_cast<const char>(241),static_cast<const char>(242),static_cast<const char>(243),static_cast<const char>(244),static_cast<const char>(245),static_cast<const char>(246),static_cast<const char>(247),static_cast<const char>(248),static_cast<const char>(249),static_cast<const char>(250),static_cast<const char>(251),static_cast<const char>(252),static_cast<const char>(253),static_cast<const char>(254),static_cast<const char>(255)
  };


//--------------------------------------------------- Complement ---------------
char AMOS::Complement (char ch)
{
  return COMPLEMENT_DNA[ int(ch) ];
}


//--------------------------------------------------- ReverseComplement --------
void AMOS::ReverseComplement(string & str)
{
  char ch;
  string::iterator lo = str.begin();
  string::iterator hi = str.end() - 1;
  while ( lo <= hi )
    {
      ch = *hi;
      *hi = COMPLEMENT_DNA[ int(*lo) ];
      *lo = COMPLEMENT_DNA[ int(ch) ];
      lo++; hi--;
    }
}


//--------------------------------------------------- ReverseComplement --------
void AMOS::ReverseComplement(char * str)
{
  char ch;
  char *lo = str;
  char *hi = str + strlen(str) - 1;
  while ( lo <= hi )
    {
      ch = *hi;
      *hi = COMPLEMENT_DNA[ int(*lo) ];
      *lo = COMPLEMENT_DNA[ int(ch) ];
      lo++; hi--;
    }
}


//--------------------------------------------------- Reverse ------------------
void AMOS::Reverse (string & str)
{
  reverse (str . begin( ), str . end( ));
}


//--------------------------------------------------- Reverse ------------------
void AMOS::Reverse (char * str)
{
  reverse (str, str + strlen (str));
}
