sudo yum install -y binutils gcc gcc-c++ gcc-plugin-devel libstdc++ libgcc glibc-static libstdc++-static || exit $?
sudo yum install -y make python wget zlib zlib-devel tar gzip xz unzip coreutils grep perl perl-local-lib perl-Time-HiRes perl-CPAN perl-File-Copy-Recursive perl-YAML perl-DBI perl-DBD-SQLite perl-libwww-perl perl-XML-Parser expat expat-devel tcsh autoconf automake || exit $?
sudo -H sh -c "yes '' | cpan -fi Statistics::Descriptive" || exit $?
if test -z $PREFIX; then
export PREFIX=/usr/local || exit $?
fi
if ! test -e .mummer; then
cd MUMmer3.23 || exit $?
make CFLAGS="-O3 -pipe -fomit-frame-pointer" CXXFLAGS="-O3 -pipe -fomit-frame-pointer" || exit $?
perl -i -npe 's/(\$AUX_BIN_DIR = ").*"/$1$ENV{"PREFIX"}\/share\/assams\/bin"/g; s/(\$BIN_DIR = ").*"/$1$ENV{"PREFIX"}\/share\/assams\/bin"/g; s/(\$SCRIPT_DIR = ").*"/$1$ENV{"PREFIX"}\/share\/assams\/scripts"/g; s/(set bindir = ).*/$1$ENV{"PREFIX"}\/share\/assams\/bin/g; s/(set scriptdir = ).*/$1$ENV{"PREFIX"}\/share\/assams\/scripts/g; s/(use lib ").*"/$1$ENV{"PREFIX"}\/share\/assams\/scripts"/g' scripts/* exact-tandems mapview mummerplot nucmer promer run-mummer1 run-mummer3 || exit $?
mv annotate mummer-annotate || exit $?
perl -i -npe 's/\$bindir\/annotate/\$bindir\/mummer-annotate/g' run-mummer1 scripts/run-mummer1.csh || exit $?
chmod 755 mummer-annotate combineMUMs delta-filter dnadiff exact-tandems gaps mapview mgaps mummer mummerplot nucmer nucmer2xfig promer repeat-match run-mummer1 run-mummer3 show-aligns show-coords show-diff show-snps show-tiling aux_bin/* || exit $?
mkdir -p $PREFIX/share/assams/bin || sudo mkdir -p $PREFIX/share/assams/bin || exit $?
mv mummer-annotate combineMUMs delta-filter dnadiff exact-tandems gaps mapview mgaps mummer mummerplot nucmer nucmer2xfig promer repeat-match run-mummer1 run-mummer3 show-aligns show-coords show-diff show-snps show-tiling aux_bin/* $PREFIX/share/assams/bin/ || sudo mv mummer-annotate combineMUMs delta-filter dnadiff exact-tandems gaps mapview mgaps mummer mummerplot nucmer nucmer2xfig promer repeat-match run-mummer1 run-mummer3 show-aligns show-coords show-diff show-snps show-tiling aux_bin/* $PREFIX/share/assams/bin/ || exit $?
chmod 755 scripts || exit $?
chmod 644 scripts/* || exit $?
cp -R scripts $PREFIX/share/assams/ || sudo cp -R scripts $PREFIX/share/assams/ || exit $?
make clean || exit $?
cd .. || exit $?
touch .mummer || exit $?
fi
if ! test -e .amos; then
cd amos-modified || exit $?
sh unbootstrap || exit $?
sh bootstrap || exit $?
if test `gcc -dumpversion | perl -ne '/^(\d+\.\d+)/;if($1>=4.8){print(1)}else{print(0)}'` -eq 1; then
CFLAGS="-O3 -pipe -fomit-frame-pointer -fopenmp" CXXFLAGS="-O3 -pipe -fomit-frame-pointer -fopenmp -std=gnu++11" LDFLAGS="-O3 -pipe -fomit-frame-pointer -fopenmp" LIBS="-lgomp" sh configure --prefix=$PREFIX/share/assams --without-Boost-dir --without-qmake-qt4 || exit $?
else
CFLAGS="-O3 -pipe -fomit-frame-pointer -fopenmp" CXXFLAGS="-O3 -pipe -fomit-frame-pointer -fopenmp" LDFLAGS="-O3 -pipe -fomit-frame-pointer -fopenmp" LIBS="-lgomp" sh configure --prefix=$PREFIX/share/assams --without-Boost-dir --without-qmake-qt4 || exit $?
fi
make || exit $?
make install-strip || sudo make install-strip || exit $?
make distclean || exit $?
cd .. || exit $?
touch .amos || exit $?
fi
if ! test -e .pblat; then
cd pblat-modified-1.6 || exit $?
make CFLAGS="-O3 -pipe -fomit-frame-pointer" || exit $?
cp pblat $PREFIX/share/assams/bin/ || sudo cp pblat $PREFIX/share/assams/bin/ || exit $?
make clean || exit $?
cd .. || exit $?
touch .pblat || exit $?
fi
make PREFIX=$PREFIX || exit $?
make PREFIX=$PREFIX install || sudo make PREFIX=$PREFIX install || exit $?
make clean || exit $?
echo "ASSAMSHOME=$PREFIX/share/assams" > ~/.assams || exit $?
